from mininet.topo import Topo

class MccTopo(Topo):
        
        # Definisco l'inizializzatore
        def __init__(self):
                
                # Chiamo l'inizializzatore del genitore
                Topo.__init__(self)
                
                # Rete missione
                hMeoc = self.addHost("hMeoc")
                s1 = self.addSwitch("s1")
                h1 = self.addHost("h1")
                h2 = self.addHost("h2")
                h3 = self.addHost("h3")
                h4 = self.addHost("h4")
                h5 = self.addHost("h5")

                self.addLink ( hMeoc, s1 )
                self.addLink ( s1, h1 )
                self.addLink ( s1, h2 )
                self.addLink ( s1, h3 )
                self.addLink ( s1, h4 )
                self.addLink ( s1, h5 )

                # Rete remota
                hSink = self.addHost("hSink")
                
                self.addLink( hSink, h1, bw=0.118, delay='100ms' )      #EDGE x1
                self.addLink( hSink, h2, bw=0.118, delay='100ms' )      #EDGE x1
                self.addLink( hSink, h3, bw=0.128, delay='70ms' )       #UMTS x2
                self.addLink( hSink, h4, bw=0.384, delay='45ms' )       #HSPA Rel.5 (HSDPA) x3
                self.addLink( hSink, h5, bw=0.118, delay='100ms' )      #EDGE x1
                
                '''
                s2 = self.addSwitch("s2")

                self.addLink ( hSink, s2 )
                self.addLink ( h1, s2 )
                self.addLink ( h2, s2 )
                self.addLink ( h3, s2 )
                self.addLink ( h4, s2 )
                self.addLink ( h5, s2 )
                '''

# Serve per poter passare la topologia da linea di comando
topos = { "test": ( lambda: MccTopo() ) }